"""
 Copyright (c) 2020 VMware, Inc. All rights reserved.
"""
from pprint import pformat
from six import iteritems
import re
from .query_result_record_type import QueryResultRecordType


class QueryResultAdminEventRecordType(QueryResultRecordType):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'entity': 'str',
        'entity_name': 'str',
        'entity_type': 'str',
        'event_id': 'str',
        'event_status': 'int',
        'event_type': 'str',
        'org': 'str',
        'org_name': 'str',
        'product_version': 'str',
        'service_namespace': 'str',
        'time_stamp': 'str',
        'user_name': 'str'
    }

    attribute_map = {
        'entity': 'entity',
        'entity_name': 'entityName',
        'entity_type': 'entityType',
        'event_id': 'eventId',
        'event_status': 'eventStatus',
        'event_type': 'eventType',
        'org': 'org',
        'org_name': 'orgName',
        'product_version': 'productVersion',
        'service_namespace': 'serviceNamespace',
        'time_stamp': 'timeStamp',
        'user_name': 'userName'
    }

    def __init__(self, entity=None,entity_name=None,entity_type=None,event_id=None,event_status=None,event_type=None,org=None,org_name=None,product_version=None,service_namespace=None,time_stamp=None,user_name=None):
        self._entity = None
        self._entity_name = None
        self._entity_type = None
        self._event_id = None
        self._event_status = None
        self._event_type = None
        self._org = None
        self._org_name = None
        self._product_version = None
        self._service_namespace = None
        self._time_stamp = None
        self._user_name = None

        if entity is not None:
            self.entity = entity
        if entity_name is not None:
            self.entity_name = entity_name
        if entity_type is not None:
            self.entity_type = entity_type
        if event_id is not None:
            self.event_id = event_id
        if event_status is not None:
            self.event_status = event_status
        if event_type is not None:
            self.event_type = event_type
        if org is not None:
            self.org = org
        if org_name is not None:
            self.org_name = org_name
        if product_version is not None:
            self.product_version = product_version
        if service_namespace is not None:
            self.service_namespace = service_namespace
        if time_stamp is not None:
            self.time_stamp = time_stamp
        if user_name is not None:
            self.user_name = user_name

    @property
    def entity(self):
        return self._entity
    
    @entity.setter
    def entity(self, entity):
        self._entity = entity

    @property
    def entity_name(self):
        return self._entity_name
    
    @entity_name.setter
    def entity_name(self, entity_name):
        self._entity_name = entity_name

    @property
    def entity_type(self):
        return self._entity_type
    
    @entity_type.setter
    def entity_type(self, entity_type):
        self._entity_type = entity_type

    @property
    def event_id(self):
        return self._event_id
    
    @event_id.setter
    def event_id(self, event_id):
        self._event_id = event_id

    @property
    def event_status(self):
        return self._event_status
    
    @event_status.setter
    def event_status(self, event_status):
        self._event_status = event_status

    @property
    def event_type(self):
        return self._event_type
    
    @event_type.setter
    def event_type(self, event_type):
        self._event_type = event_type

    @property
    def org(self):
        return self._org
    
    @org.setter
    def org(self, org):
        self._org = org

    @property
    def org_name(self):
        return self._org_name
    
    @org_name.setter
    def org_name(self, org_name):
        self._org_name = org_name

    @property
    def product_version(self):
        return self._product_version
    
    @product_version.setter
    def product_version(self, product_version):
        self._product_version = product_version

    @property
    def service_namespace(self):
        return self._service_namespace
    
    @service_namespace.setter
    def service_namespace(self, service_namespace):
        self._service_namespace = service_namespace

    @property
    def time_stamp(self):
        return self._time_stamp
    
    @time_stamp.setter
    def time_stamp(self, time_stamp):
        self._time_stamp = time_stamp

    @property
    def user_name(self):
        return self._user_name
    
    @user_name.setter
    def user_name(self, user_name):
        self._user_name = user_name


    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryResultAdminEventRecordType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
