"""
 Copyright (c) 2020 VMware, Inc. All rights reserved.
"""
from pprint import pformat
from six import iteritems
import re
from .v_cloud_extensible_type import VCloudExtensibleType


class TenantErrorType(VCloudExtensibleType):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'major_error_code': 'int',
        'message': 'str',
        'minor_error_code': 'str',
        'vendor_specific_error_code': 'str'
    }

    attribute_map = {
        'major_error_code': 'majorErrorCode',
        'message': 'message',
        'minor_error_code': 'minorErrorCode',
        'vendor_specific_error_code': 'vendorSpecificErrorCode'
    }

    def __init__(self, major_error_code=None,message=None,minor_error_code=None,vendor_specific_error_code=None):
        self._major_error_code = None
        self._message = None
        self._minor_error_code = None
        self._vendor_specific_error_code = None

        if major_error_code is not None:
            self.major_error_code = major_error_code
        if message is not None:
            self.message = message
        if minor_error_code is not None:
            self.minor_error_code = minor_error_code
        if vendor_specific_error_code is not None:
            self.vendor_specific_error_code = vendor_specific_error_code

    @property
    def major_error_code(self):
        return self._major_error_code
    
    @major_error_code.setter
    def major_error_code(self, major_error_code):
        self._major_error_code = major_error_code

    @property
    def message(self):
        return self._message
    
    @message.setter
    def message(self, message):
        self._message = message

    @property
    def minor_error_code(self):
        return self._minor_error_code
    
    @minor_error_code.setter
    def minor_error_code(self, minor_error_code):
        self._minor_error_code = minor_error_code

    @property
    def vendor_specific_error_code(self):
        return self._vendor_specific_error_code
    
    @vendor_specific_error_code.setter
    def vendor_specific_error_code(self, vendor_specific_error_code):
        self._vendor_specific_error_code = vendor_specific_error_code


    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TenantErrorType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
